addpath catacamera_mexfuncs

% Create C++ class
% The file 'model_parameters.bin' was
% generated by the calibration toolbox by the [Save] button
cata_class = CataCamera_new('model_parameters.bin');

% Define points (several points can be projected at once)
P = [-5 2;
     4 0;
     -1 1];

% Project 3D points
[u,v] = CataCamera_space2plane(cata_class, P(1,:), P(2,:), P(3,:));

% Compare with matlab result
if 0
  P = [-5;4;-1];
  V = CataCamera_getV(cata_class);
  [P_m,dP_mdX] = spaceToImgPlane(P, V)

  [u,v,dudx,dvdx,dudy,dvdy,dudz,dvdz] = CataCamera_space2plane(cata_class, P(1,:), P(2,:), P(3,:));

  P = [u;v]
  dPdX = [dudx dudy dudz;
	  dvdx dvdy dvdz]
  return
end


% We normalise the points to be able to compare
% them with the lifting to the unit sphere
P(:,1) = P(:,1)/norm(P(:,1));
P(:,2) = P(:,2)/norm(P(:,2))

% Lift image points to unit sphere
[X,Y,Z] = CataCamera_lift_sphere(cata_class, u, v);
P2 = [X;Y;Z]

% Destroy class
CataCamera_delete(cata_class);

