/*
 * This file was automatically generated for MATLAB by wrap_matlab on
 * Thu Sep 29 21:25:57 2005
 * from simple.h.
 */

#include "simple.h"

#ifndef __GNUC__
#include <alloca.h>
#endif
#define MEM_ALLOC(type, n, size) ((type)alloca((n)*(size)))

#ifdef __cplusplus
extern "C" {
#endif
#include "matrix.h"
#include "mex.h"
#ifdef __cplusplus
}
#endif
#include <complex.h>

//
// Return the maximum of the arguments:
//
template <class FLOAT>
inline FLOAT
max(FLOAT arg1, FLOAT arg2)
{
  return arg1 >= arg2 ? arg1 : arg2;
}

/*
 * Return the number of dimensions of an array.
 * This is not well-defined in matlab; we just return the highest dimension
 * which is not 1.
 */
static int
_n_dims(const mxArray *mat)
{
  int n_dim = mxGetNumberOfDimensions(mat); /* Get what matlab thinks. */
  if (n_dim == 2 && mxGetN(mat) == 1) /* 2D array with # of columns = 1? */
  {
    n_dim = 1;			/* It's really a 1D array. */
    if (mxGetM(mat) == 1)	/* Also only one row? */
      n_dim = 0;		/* It's really a scalar. */
  }

  return n_dim;
}

/*
 * Function to get the total number of elements in an array.
 * Arguments:
 * 1) The matlab object.
 *
 * If the object is a scalar, the array length is 1.
 */
static int
_arraylen(const mxArray *mat) {
  int len = 1;
  const int *dims = mxGetDimensions(mat); // Get the number of dimensions.
  int idx;
  for (idx = 0; idx < mxGetNumberOfDimensions(mat); ++idx)
    len *= dims[idx];		// Multiply all the dimensions.

  return len;
}

//
// Get the n'th dimension of a Matlab object.
// Arguments:
// 1) The matlab matrix.
// 2) Which dimension.  0 for the most quickly varying one, etc.
//
static inline int
_dim(const mxArray *mat, int idxno) {
  if (idxno >= mxGetNumberOfDimensions(mat))	// Illegal # of dims?
    return 1;
  else
    return mxGetDimensions(mat)[idxno];	// Return the dimension.
}

//
// Load up an array (which may consist only of a single element) with
// the values from a matlab object.  Arguments:
// 1) The matlab object.
// 2) Where to put the values.  The array should be allocated sufficiently
//    large so that all of the values in the matlab object can be converted.
//
// These functions return 0 on error, or 1 if the operation succeded.
//
template <class FLOAT>
static int
_get_numeric(const mxArray *mat, FLOAT *arr) // float or double.
{
  int idx;
  int n_elements = _arraylen(mat); // Get the length.

  if (mxIsDouble(mat))		// Ordinary double precision matrix?
  {
    double *pr = mxGetPr(mat);	// Point to vector of double precision values.

    for (idx = 0; idx < n_elements; ++idx) // Loop through all elements.
      *arr++ = (FLOAT)*pr++;	// Convert and copy this element.
  }
  else if (mxIsInt32(mat) || mxIsUint32(mat)) // 32 bit integer?
  {
    INT32_T *pr = (INT32_T *)mxGetData(mat); // Point to the data.
    for (idx = 0; idx < n_elements; ++idx) // Loop through all elements.
      *arr++ = (FLOAT)*pr++;	// Convert and copy this element.
  }
  else if (mxIsInt16(mat) || mxIsUint16(mat)) // 16 bit integer?
  {
    INT16_T *pr = (INT16_T *)mxGetData(mat); // Point to the data.
    for (idx = 0; idx < n_elements; ++idx) // Loop through all elements.
      *arr++ = (FLOAT)*pr++;	// Convert and copy this element.
  }
  else if (mxIsInt8(mat) || mxIsUint8(mat)) // 8 bit integer?
  {
    INT8_T *pr = (INT8_T *)mxGetData(mat); // Point to the data.
    for (idx = 0; idx < n_elements; ++idx) // Loop through all elements.
      *arr++ = (FLOAT)*pr++;	// Convert and copy this element.
  }
  else				// Don't know what this is.
    return 0;			// Type conversion error.

  return 1;			// No error.
}

//
// A version of the above function for complex numbers:
//
template <class FLOAT>
static int
_get_complex(const mxArray *mat, complex<FLOAT> *arr)
{
  int idx;
  int n_elements = _arraylen(mat); // Get the length.

  if (mxIsDouble(mat))		// Ordinary double precision matrix?
  {
    double *pr = mxGetPr(mat);	// Point to vector of double precision values.
    double *pi = mxGetPi(mat);	// Get complex part, if any.

    if (pi != 0)		// Is there a complex part?
    {
      for (idx = 0; idx < n_elements; ++idx) // Loop through all elements.
        *arr++ = complex<FLOAT>((FLOAT)*pr++, (FLOAT)*pi++);
				// Convert and copy this element.
    }
    else			// Purely real matrix:
    {
      for (idx = 0; idx < n_elements; ++idx) // Loop through all elements.
        *arr++ = complex<FLOAT>((FLOAT)*pr++, 0);
				// Convert and copy this element, setting
				// the imaginary part to 0.
    }

    return 1;			// No error.
  }
  else				// Currently we don't support the int32, int16,
				// or int8 types.
    return 0;			// Type conversion error.
}

/*
 * Check to see if the vectorizing dimensions on an input argument are
 * ok.  Arguments:
 * 1) The input argument.
 * 2) The number of vectorizing dimensions we have so far.  This is updated
 *    if we add more vectorizing dimensions.
 * 3) An array containing the existing vectorizing dimensions.
 * 4) The number of explicitly declared dimensions, i.e., 0 if this was
 *    declared as a scalar, 1 if a vector.  We vectorize only the dimensions
 *    higher than the explicitly declared ones.
 * 5) A value which is set to 0 if this argument is not vectorized.  This
 *    value is left unaltered if the argument is vectorized.
 *
 * Returns 0 if there was a problem, 1 if the dimensions were ok.
 */
int
_check_input_vectorize(const mxArray *arg,
                       int *n_vec_dim,
		       int _d[4],
		       int explicit_dims,
		       int *vec_stride)
{
  int v_idx;

  int n_dims = _n_dims(arg);

  if (n_dims > explicit_dims)	/* Any additional dimensions? */
  {
    if (*n_vec_dim == 0)	/* No vectorizing dimensions seen yet? */
    {				/* This defines the vectorizing dimensions. */
      *n_vec_dim = n_dims - explicit_dims; /* Remember the # of dims. */
      for (v_idx = 0; v_idx < 4-explicit_dims; ++v_idx)
        _d[v_idx] = _dim(arg, v_idx+explicit_dims); /* Remember this dim. */
    } 
    else			/* Already had some vectorizing dimensions. */
    {				/* These must match exactly. */
      for (v_idx = 0; v_idx < 4-explicit_dims; ++v_idx)
        if (_d[v_idx] != _dim(arg, v_idx+explicit_dims)) /* Wrong size? */
          return 0;		/* Error! */
    }
  }  
/*  else if (n_dims < explicit_dims) */ /* Too few dimensions? */
/*    return 0; */ /* We don't do this check because there's no way to
		    * distinguish between a vector and a 3x1 matrix. */
  else
    *vec_stride = 0;		/* Vectorization not required. */

  return 1;
}

/*
 * Same thing except for modify variables.  Arguments:
 * 1) The input argument.
 * 2) The number of vectorizing dimensions we have so far.
 * 3) An array containing the existing vectorizing dimensions.
 * 4) The number of explicitly declared dimensions, i.e., 0 if this was
 *    declared as a scalar, 1 if a vector.  We vectorize only the dimensions
 *    higher than the explicitly declared ones.
 * 5) A flag indicating whether this is the first modify variable.  This
 *    flag is passed by reference and updated by this subroutine.
 *
 * The vectorizing dimensions of modify arguments must exactly match those
 * specified for input variables.  The difference between this subroutine
 * and _check_input_vectorize is that only the first modify variable may
 * specify additional vectorizing dimensions.
 *
 * Returns 0 if there was a problem, 1 if the dimensions were ok.
 */
int
_check_modify_vectorize(const mxArray *arg,
		        int *n_vec_dim,
		        int _d[4],
		        int explicit_dims,
			int *first_modify_flag)
{
  int v_idx;

  int n_dims = _n_dims(arg);

  if (n_dims > explicit_dims)	/* Any additional dimensions? */
  {
    if (*n_vec_dim == 0 && *first_modify_flag)	/* No vectorizing dimensions seen yet? */
    {				/* This defines the vectorizing dimensions. */
      *n_vec_dim = n_dims - explicit_dims; /* Remember the # of dims. */
      for (v_idx = 0; v_idx < 4-explicit_dims; ++v_idx)
        _d[v_idx] = _dim(arg, v_idx+explicit_dims); /* Remember this dim. */
    } 
    else			/* Already had some vectorizing dimensions. */
    {				/* These must match exactly. */
      for (v_idx = 0; v_idx < 4-explicit_dims; ++v_idx)
        if (_d[v_idx] != _dim(arg, v_idx+explicit_dims)) /* Wrong size? */
          return 0;		/* Error! */
    }
  }  
/*  else if (n_dims < explicit_dims) */ /* Too few dimensions? */
/*    return 0; */ /* We don't do this check because there's no way to
		    * distinguish between a vector and a 3x1 matrix. */

  *first_modify_flag = 0;	/* Next modify variable will not be first. */
  return 1;
}


/*
 * Convert between classes, handling inheritance relationships.
 * Arguments:
 * 1) The pointer.
 * 2) The type code for its class.
 * 3) The type code for the class you want.
 *
 * Returns 0 if the conversion is illegal, or else returns the
 * desired pointer.
 * We assume that you have already verified that the type code does
 * not match, so the only valid possibility is an inheritance
 * relationship.
 */
static void *
__cvt_type(void *, unsigned, unsigned)
{
  return 0;
}

//
// Local functions dealing with pointers:
//
// Pointers are stored as complex numbers.  The real part is the pointer
// value, and the complex part is the type code.  Since the real part will be
// a double precision number, the pointer is guaranteed to fit, even on
// 64-bit machines.
//
// Fill an array with pointers.  Arguments:
// 1) A pointer to the array to fill.  The array is already the correct size.
// 2) The matlab object.
// 3) The pointer type code.
//
// Returns false if some of the pointers have the wrong type.
//
static int
_get_pointer(void **arr, const mxArray *mat, unsigned typecode)
{
  int idx;
  int n_elements;
  double *pr, *pi;

  if (!mxIsComplex(mat))	// Make sure it's the right type.
    return 0;

  n_elements = _arraylen(mat);	// Get the number of elements to convert.
  pr = mxGetPr(mat);		// Get a pointer to the real part.
  pi = mxGetPi(mat);		// Get a pointer to the complex part.
  for (idx = 0; idx < n_elements; ++idx)
  {				// Look at each element:
    unsigned this_typecode = (unsigned)*pi++; // Get the type code.
    if (this_typecode == typecode) // Correct type?
      *arr++ = *(void **)pr;	// Do the conversion.
    else
    {
      *arr = __cvt_type(*(void **)pr, this_typecode, typecode);
				// Check inheritance.
      if (*arr++ == 0) return 0; // Wrong type.
    }

    ++pr;			// Point to the next element.
  }

  return 1;			// No error.
}

//
// Load a matrix with a pointer or an array of pointers.  This assumes
// that the matrix has already been allocated to the correct size
// (that's how we know how many elements to convert).
//
static void
_put_pointer(mxArray *mat, void **ptr_array, double type_code)
{
  int idx;
  int n_elements;
  double *pr, *pi;
 
  n_elements = _arraylen(mat);	// Get the number of elements to convert.
  pr = mxGetPr(mat);		// Get a pointer to the real part.
  pi = mxGetPi(mat);		// Get a pointer to the complex part.

  for (idx = 0; idx < n_elements; ++idx)
  {
    *pi++ = type_code;		// Remember the type code.
    *pr = 0;			// Wipe out any extra bits the address
				// doesn't cover, in case we're on a
				// 32 bit machine.
    *(void **)pr = *ptr_array++; // Remember the address.
    ++pr;			// Advance the pointer.
  }
}
void _wrap_get_some_global_var(int nlhs, mxArray **plhs, int nrhs, const mxArray **)
{
  if (nlhs > 1 ||
      nrhs != 0+1)
    mexErrMsgTxt("Wrong number of arguments to function get_some_global_var");
  float _arg_retval;
  plhs[0] = mxCreateDoubleMatrix(1, 1, mxREAL);
    _arg_retval = (float)
      some_global_var;
  *mxGetPr(plhs[0]) = (double)_arg_retval;
}

void _wrap_set_some_global_var(int nlhs, mxArray **, int nrhs, const mxArray **prhs)
{
  if (nlhs != 0 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function set_some_global_var");
  float _arg_newval;
  if (_n_dims(prhs[1]) > 0)
    mexErrMsgTxt("Error in dimension of argument newval");
  if (!_get_numeric(prhs[1], &_arg_newval))
    mexErrMsgTxt("Expecting numeric scalar for argument newval");

    some_global_var = _arg_newval;
}

void _wrap_flip_case(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs > 1 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function flip_case");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  char *_arg_c;
  char *_arg_retval;
  int _vecstride_c = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 0, &_vecstride_c))
    mexErrMsgTxt("Error in dimension of argument c");
  _arg_c = MEM_ALLOC(char *, _arraylen(prhs[1])+1, sizeof (char));
  if (!mxIsChar(prhs[1]))
    mexErrMsgTxt("Expecting string for argument c");
  mxGetString(prhs[1], _arg_c, mxGetN(prhs[1])+1);

  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[0] = mxCreateCharArray(max((0 + _vec_n), 2), _ds);
    _arg_retval = MEM_ALLOC(char *, _arraylen(plhs[0]), sizeof (char));
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    _arg_retval[_vidx] = (char)
      flip_case(_arg_c[_vecstride_c*_vidx]);
  }
  {
    int _cidx;
    mxChar *mc_ptr = (mxChar *)mxGetPr(plhs[0]);
    for (_cidx = 0; _cidx < _arraylen(plhs[0]); ++_cidx)
      *mc_ptr++ = (mxChar)*_arg_retval++;
  }
}

void _wrap_get_str(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs > 1 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function get_str");
  unsigned _arg_idx;
  char * _arg_retval;
  if (_n_dims(prhs[1]) > 0)
    mexErrMsgTxt("Error in dimension of argument idx");
  if (!_get_numeric(prhs[1], &_arg_idx))
    mexErrMsgTxt("Expecting numeric scalar for argument idx");

    _arg_retval = (char *)
      get_str(_arg_idx);
  plhs[0] = mxCreateString(_arg_retval);
}

void _wrap_print_cmat(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs > 1 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function print_cmat");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  char *_arg_mat;
  unsigned _arg_m;
  unsigned _arg_n;
  char *_arg_mat_out;
  _arg_n = (_dim(prhs[1], 1));
  _arg_m = (_dim(prhs[1], 0));
  int _vecstride_mat = _arg_m*_arg_n;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 2, &_vecstride_mat))
    mexErrMsgTxt("Error in dimension of argument mat");
  _arg_mat = MEM_ALLOC(char *, _arraylen(prhs[1])+1, sizeof (char));
  if (!mxIsChar(prhs[1]))
    mexErrMsgTxt("Expecting string for argument mat");
  mxGetString(prhs[1], _arg_mat, mxGetN(prhs[1])+1);

  {
    int _ds[] = { _arg_m, _arg_n, _d[0] , _d[1]  };
    plhs[0] = mxCreateCharArray(max((2 + _vec_n), 2), _ds);
    _arg_mat_out = MEM_ALLOC(char *, _arraylen(plhs[0]), sizeof (char));
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    print_cmat(&_arg_mat[_vecstride_mat*_vidx], _arg_m, _arg_n, &_arg_mat_out[_arg_m*_arg_n*_vidx]);
  }
  {
    int _cidx;
    mxChar *mc_ptr = (mxChar *)mxGetPr(plhs[0]);
    for (_cidx = 0; _cidx < _arraylen(plhs[0]); ++_cidx)
      *mc_ptr++ = (mxChar)*_arg_mat_out++;
  }
}

void _wrap_print_mat(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs > 1 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function print_mat");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  float *_arg_mat;
  unsigned _arg_m;
  unsigned _arg_n;
  float *_arg_mat_out;
  _arg_n = (_dim(prhs[1], 1));
  _arg_m = (_dim(prhs[1], 0));
  int _vecstride_mat = _arg_m*_arg_n;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 2, &_vecstride_mat))
    mexErrMsgTxt("Error in dimension of argument mat");
  _arg_mat = MEM_ALLOC(float *, _arraylen(prhs[1]), sizeof (float));
  if (!_get_numeric(prhs[1], _arg_mat))
    mexErrMsgTxt("Expecting numeric matrix for argument mat");

  {
    int _ds[] = { _arg_m, _arg_n, _d[0] , _d[1]  };
    plhs[0] = mxCreateNumericArray(max((2 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_mat_out = MEM_ALLOC(float *, _arraylen(plhs[0]), sizeof (float));
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    print_mat(&_arg_mat[_vecstride_mat*_vidx], _arg_m, _arg_n, &_arg_mat_out[_arg_m*_arg_n*_vidx]);
  }
  {
    int _fidx;
    double *d_ptr = mxGetPr(plhs[0]);
    for (_fidx = 0; _fidx < _arraylen(plhs[0]); ++_fidx)
      *d_ptr++ = (double)*_arg_mat_out++;
  }
}

void _wrap_print_num(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs > 1 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function print_num");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  float *_arg_num;
  float *_arg_retval;
  int _vecstride_num = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 0, &_vecstride_num))
    mexErrMsgTxt("Error in dimension of argument num");
  _arg_num = MEM_ALLOC(float *, _arraylen(prhs[1]), sizeof (float));
  if (!_get_numeric(prhs[1], _arg_num))
    mexErrMsgTxt("Expecting numeric matrix for argument num");

  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[0] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_retval = MEM_ALLOC(float *, _arraylen(plhs[0]), sizeof (float));
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    _arg_retval[_vidx] = (float)
      print_num(_arg_num[_vecstride_num*_vidx]);
  }
  {
    int _fidx;
    double *d_ptr = mxGetPr(plhs[0]);
    for (_fidx = 0; _fidx < _arraylen(plhs[0]); ++_fidx)
      *d_ptr++ = (double)*_arg_retval++;
  }
}

void _wrap_print_str(int nlhs, mxArray **, int nrhs, const mxArray **prhs)
{
  if (nlhs != 0 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function print_str");
  char * _arg_str;
  if (0 > 0)
    mexErrMsgTxt("Error in dimension of argument str");
  if (!mxIsChar(prhs[1]))
    mexErrMsgTxt("Expecting string for argument str");
  _arg_str = MEM_ALLOC(char *, mxGetN(prhs[1]) + 1, sizeof (char));
  mxGetString(prhs[1], _arg_str, mxGetN(prhs[1])+1);

    print_str(_arg_str);
}

void _wrap_print_vec(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs > 1 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function print_vec");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  float *_arg_v;
  unsigned _arg_n;
  float *_arg_v_out;
  _arg_n = (_dim(prhs[1], 0));
  int _vecstride_v = _arg_n;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 1, &_vecstride_v))
    mexErrMsgTxt("Error in dimension of argument v");
  _arg_v = MEM_ALLOC(float *, _arraylen(prhs[1]), sizeof (float));
  if (!_get_numeric(prhs[1], _arg_v))
    mexErrMsgTxt("Expecting numeric matrix for argument v");

  {
    int _ds[] = { _arg_n, _d[0] , _d[1] , _d[2]  };
    plhs[0] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_v_out = MEM_ALLOC(float *, _arraylen(plhs[0]), sizeof (float));
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    print_vec(&_arg_v[_vecstride_v*_vidx], _arg_n, &_arg_v_out[_arg_n*_vidx]);
  }
  {
    int _fidx;
    double *d_ptr = mxGetPr(plhs[0]);
    for (_fidx = 0; _fidx < _arraylen(plhs[0]); ++_fidx)
      *d_ptr++ = (double)*_arg_v_out++;
  }
}

void _wrap_real_strcmp(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs > 1 ||
      nrhs != 2+1)
    mexErrMsgTxt("Wrong number of arguments to function real_strcmp");
  char * _arg__arg1;
  char * _arg__arg2;
  int _arg_retval;
  if (0 > 0)
    mexErrMsgTxt("Error in dimension of argument _arg1");
  if (!mxIsChar(prhs[1]))
    mexErrMsgTxt("Expecting string for argument _arg1");
  _arg__arg1 = MEM_ALLOC(char *, mxGetN(prhs[1]) + 1, sizeof (char));
  mxGetString(prhs[1], _arg__arg1, mxGetN(prhs[1])+1);

  if (0 > 0)
    mexErrMsgTxt("Error in dimension of argument _arg2");
  if (!mxIsChar(prhs[2]))
    mexErrMsgTxt("Expecting string for argument _arg2");
  _arg__arg2 = MEM_ALLOC(char *, mxGetN(prhs[2]) + 1, sizeof (char));
  mxGetString(prhs[2], _arg__arg2, mxGetN(prhs[2])+1);

  plhs[0] = mxCreateDoubleMatrix(1, 1, mxREAL);
    _arg_retval = (int)
      strcmp(_arg__arg1, _arg__arg2);
  *mxGetPr(plhs[0]) = (double)_arg_retval;
}

void _wrap_abc_delete(int nlhs, mxArray **, int nrhs, const mxArray **prhs)
{
  if (nlhs != 0 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function abc_delete");
  abc * _arg_THIS;
  if (_n_dims(prhs[1]) > 0)
    mexErrMsgTxt("Error in dimension of argument THIS");
  if (!_get_pointer((void **)&_arg_THIS, prhs[1], 301728)) /* abc * */
    mexErrMsgTxt("Wrong pointer type, expecting abc * for argument THIS");

    delete _arg_THIS;
}

void _wrap_abc_get_ghi(int nlhs, mxArray **plhs, int nrhs, const mxArray **)
{
  if (nlhs > 1 ||
      nrhs != 0+1)
    mexErrMsgTxt("Wrong number of arguments to function abc_get_ghi");
  float _arg_retval;
  plhs[0] = mxCreateDoubleMatrix(1, 1, mxREAL);
    _arg_retval = (float)
      abc::ghi;
  *mxGetPr(plhs[0]) = (double)_arg_retval;
}

void _wrap_abc_set_ghi(int nlhs, mxArray **, int nrhs, const mxArray **prhs)
{
  if (nlhs != 0 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function abc_set_ghi");
  float _arg_newval;
  if (_n_dims(prhs[1]) > 0)
    mexErrMsgTxt("Error in dimension of argument newval");
  if (!_get_numeric(prhs[1], &_arg_newval))
    mexErrMsgTxt("Expecting numeric scalar for argument newval");

    abc::ghi = _arg_newval;
}

void _wrap_abc_get_jkl(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs > 1 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function abc_get_jkl");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  abc * *_arg_THIS;
  float *_arg_retval;
  int _vecstride_THIS = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 0, &_vecstride_THIS))
    mexErrMsgTxt("Error in dimension of argument THIS");
  _arg_THIS =
    MEM_ALLOC(abc * *, _arraylen(prhs[1]), sizeof (abc *));
  if (!_get_pointer((void **)_arg_THIS, prhs[1], 301728)) /* abc * */
    mexErrMsgTxt("Wrong pointer type, expecting abc * for argument THIS");

  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[0] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_retval = MEM_ALLOC(float *, _arraylen(plhs[0]), sizeof (float));
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    _arg_retval[_vidx] = (float)
      (_arg_THIS[_vecstride_THIS*_vidx])->jkl;
  }
  {
    int _fidx;
    double *d_ptr = mxGetPr(plhs[0]);
    for (_fidx = 0; _fidx < _arraylen(plhs[0]); ++_fidx)
      *d_ptr++ = (double)*_arg_retval++;
  }
}

void _wrap_abc_set_jkl(int nlhs, mxArray **, int nrhs, const mxArray **prhs)
{
  if (nlhs != 0 ||
      nrhs != 2+1)
    mexErrMsgTxt("Wrong number of arguments to function abc_set_jkl");
  abc * _arg_THIS;
  float _arg_newval;
  if (_n_dims(prhs[1]) > 0)
    mexErrMsgTxt("Error in dimension of argument THIS");
  if (!_get_pointer((void **)&_arg_THIS, prhs[1], 301728)) /* abc * */
    mexErrMsgTxt("Wrong pointer type, expecting abc * for argument THIS");

  if (_n_dims(prhs[2]) > 0)
    mexErrMsgTxt("Error in dimension of argument newval");
  if (!_get_numeric(prhs[2], &_arg_newval))
    mexErrMsgTxt("Expecting numeric scalar for argument newval");

    (_arg_THIS)->jkl = _arg_newval;
}

void _wrap_abc_jkl_plus(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs > 1 ||
      nrhs != 2+1)
    mexErrMsgTxt("Wrong number of arguments to function abc_jkl_plus");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  abc * *_arg_THIS;
  float *_arg_x;
  float *_arg_retval;
  int _vecstride_THIS = 1;
  int _vecstride_x = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 0, &_vecstride_THIS))
    mexErrMsgTxt("Error in dimension of argument THIS");
  _arg_THIS =
    MEM_ALLOC(abc * *, _arraylen(prhs[1]), sizeof (abc *));
  if (!_get_pointer((void **)_arg_THIS, prhs[1], 301728)) /* abc * */
    mexErrMsgTxt("Wrong pointer type, expecting abc * for argument THIS");

  if (!_check_input_vectorize(prhs[2], &_vec_n, _d, 0, &_vecstride_x))
    mexErrMsgTxt("Error in dimension of argument x");
  _arg_x = MEM_ALLOC(float *, _arraylen(prhs[2]), sizeof (float));
  if (!_get_numeric(prhs[2], _arg_x))
    mexErrMsgTxt("Expecting numeric matrix for argument x");

  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[0] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_retval = MEM_ALLOC(float *, _arraylen(plhs[0]), sizeof (float));
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    _arg_retval[_vidx] = (float)
      (_arg_THIS[_vecstride_THIS*_vidx])->jkl_plus(_arg_x[_vecstride_x*_vidx]);
  }
  {
    int _fidx;
    double *d_ptr = mxGetPr(plhs[0]);
    for (_fidx = 0; _fidx < _arraylen(plhs[0]); ++_fidx)
      *d_ptr++ = (double)*_arg_retval++;
  }
}

void _wrap_abc_new(int nlhs, mxArray **plhs, int nrhs, const mxArray **)
{
  if (nlhs > 1 ||
      nrhs != 0+1)
    mexErrMsgTxt("Wrong number of arguments to function abc_new");
  abc * _arg_retval;
  plhs[0] = mxCreateDoubleMatrix(1, 1, mxCOMPLEX);
    _arg_retval = (abc *)
      new abc();
  _put_pointer(plhs[0], (void **)&_arg_retval, 301728); /* abc * */
}



/*
 * The main dispatch function.  This function calls the appropriate wrapper
 * based on the value of the first argument.
 */

#ifdef __cplusplus
extern "C" {
#endif

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) {
  if (nrhs == 0 || !mxIsDouble(prhs[0]) ||
      mxGetM(prhs[0]) != 1 || mxGetN(prhs[0]) != 1)
    mexErrMsgTxt("Illegal call to mex functions in simple_matlab");
  switch ((int)(mxGetScalar(prhs[0]))) {
  case 0: _wrap_get_some_global_var(nlhs, plhs, nrhs, prhs); break;
  case 1: _wrap_set_some_global_var(nlhs, plhs, nrhs, prhs); break;
  case 2: _wrap_flip_case(nlhs, plhs, nrhs, prhs); break;
  case 3: _wrap_get_str(nlhs, plhs, nrhs, prhs); break;
  case 4: _wrap_print_cmat(nlhs, plhs, nrhs, prhs); break;
  case 5: _wrap_print_mat(nlhs, plhs, nrhs, prhs); break;
  case 6: _wrap_print_num(nlhs, plhs, nrhs, prhs); break;
  case 7: _wrap_print_str(nlhs, plhs, nrhs, prhs); break;
  case 8: _wrap_print_vec(nlhs, plhs, nrhs, prhs); break;
  case 9: _wrap_real_strcmp(nlhs, plhs, nrhs, prhs); break;
  case 10: _wrap_abc_delete(nlhs, plhs, nrhs, prhs); break;
  case 11: _wrap_abc_get_ghi(nlhs, plhs, nrhs, prhs); break;
  case 12: _wrap_abc_set_ghi(nlhs, plhs, nrhs, prhs); break;
  case 13: _wrap_abc_get_jkl(nlhs, plhs, nrhs, prhs); break;
  case 14: _wrap_abc_set_jkl(nlhs, plhs, nrhs, prhs); break;
  case 15: _wrap_abc_jkl_plus(nlhs, plhs, nrhs, prhs); break;
  case 16: _wrap_abc_new(nlhs, plhs, nrhs, prhs); break;

  default: mexErrMsgTxt("Illegal function ID parameter");
  }
}

#ifdef __cplusplus
}
#endif
