/*
 * This file was automatically generated for MATLAB by wrap_matlab on
 * Wed Aug  9 10:34:33 2006
 * from CataCamera.h.
 */

#include "CataCamera.h"

#ifndef __GNUC__
#include <alloca.h>
#endif
#define MEM_ALLOC(type, n, size) ((type)alloca((n)*(size)))

#ifdef __cplusplus
extern "C" {
#endif
#include "matrix.h"
#include "mex.h"
#ifdef __cplusplus
}
#endif
#include <complex.h>

//
// Return the maximum of the arguments:
//
template <class FLOAT>
inline FLOAT
max(FLOAT arg1, FLOAT arg2)
{
  return arg1 >= arg2 ? arg1 : arg2;
}

/*
 * Return the number of dimensions of an array.
 * This is not well-defined in matlab; we just return the highest dimension
 * which is not 1.
 */
static int
_n_dims(const mxArray *mat)
{
  int n_dim = mxGetNumberOfDimensions(mat); /* Get what matlab thinks. */
  if (n_dim == 2 && mxGetN(mat) == 1) /* 2D array with # of columns = 1? */
  {
    n_dim = 1;			/* It's really a 1D array. */
    if (mxGetM(mat) == 1)	/* Also only one row? */
      n_dim = 0;		/* It's really a scalar. */
  }

  return n_dim;
}

/*
 * Function to get the total number of elements in an array.
 * Arguments:
 * 1) The matlab object.
 *
 * If the object is a scalar, the array length is 1.
 */
static int
_arraylen(const mxArray *mat) {
  int len = 1;
  const int *dims = mxGetDimensions(mat); // Get the number of dimensions.
  int idx;
  for (idx = 0; idx < mxGetNumberOfDimensions(mat); ++idx)
    len *= dims[idx];		// Multiply all the dimensions.

  return len;
}

//
// Get the n'th dimension of a Matlab object.
// Arguments:
// 1) The matlab matrix.
// 2) Which dimension.  0 for the most quickly varying one, etc.
//
static inline int
_dim(const mxArray *mat, int idxno) {
  if (idxno >= mxGetNumberOfDimensions(mat))	// Illegal # of dims?
    return 1;
  else
    return mxGetDimensions(mat)[idxno];	// Return the dimension.
}

//
// Load up an array (which may consist only of a single element) with
// the values from a matlab object.  Arguments:
// 1) The matlab object.
// 2) Where to put the values.  The array should be allocated sufficiently
//    large so that all of the values in the matlab object can be converted.
//
// These functions return 0 on error, or 1 if the operation succeded.
//
template <class FLOAT>
static int
_get_numeric(const mxArray *mat, FLOAT *arr) // float or double.
{
  int idx;
  int n_elements = _arraylen(mat); // Get the length.

  if (mxIsDouble(mat))		// Ordinary double precision matrix?
  {
    double *pr = mxGetPr(mat);	// Point to vector of double precision values.

    for (idx = 0; idx < n_elements; ++idx) // Loop through all elements.
      *arr++ = (FLOAT)*pr++;	// Convert and copy this element.
  }
  else if (mxIsInt32(mat) || mxIsUint32(mat)) // 32 bit integer?
  {
    INT32_T *pr = (INT32_T *)mxGetData(mat); // Point to the data.
    for (idx = 0; idx < n_elements; ++idx) // Loop through all elements.
      *arr++ = (FLOAT)*pr++;	// Convert and copy this element.
  }
  else if (mxIsInt16(mat) || mxIsUint16(mat)) // 16 bit integer?
  {
    INT16_T *pr = (INT16_T *)mxGetData(mat); // Point to the data.
    for (idx = 0; idx < n_elements; ++idx) // Loop through all elements.
      *arr++ = (FLOAT)*pr++;	// Convert and copy this element.
  }
  else if (mxIsInt8(mat) || mxIsUint8(mat)) // 8 bit integer?
  {
    INT8_T *pr = (INT8_T *)mxGetData(mat); // Point to the data.
    for (idx = 0; idx < n_elements; ++idx) // Loop through all elements.
      *arr++ = (FLOAT)*pr++;	// Convert and copy this element.
  }
  else				// Don't know what this is.
    return 0;			// Type conversion error.

  return 1;			// No error.
}

//
// A version of the above function for complex numbers:
//
template <class FLOAT>
static int
_get_complex(const mxArray *mat, complex<FLOAT> *arr)
{
  int idx;
  int n_elements = _arraylen(mat); // Get the length.

  if (mxIsDouble(mat))		// Ordinary double precision matrix?
  {
    double *pr = mxGetPr(mat);	// Point to vector of double precision values.
    double *pi = mxGetPi(mat);	// Get complex part, if any.

    if (pi != 0)		// Is there a complex part?
    {
      for (idx = 0; idx < n_elements; ++idx) // Loop through all elements.
        *arr++ = complex<FLOAT>((FLOAT)*pr++, (FLOAT)*pi++);
				// Convert and copy this element.
    }
    else			// Purely real matrix:
    {
      for (idx = 0; idx < n_elements; ++idx) // Loop through all elements.
        *arr++ = complex<FLOAT>((FLOAT)*pr++, 0);
				// Convert and copy this element, setting
				// the imaginary part to 0.
    }

    return 1;			// No error.
  }
  else				// Currently we don't support the int32, int16,
				// or int8 types.
    return 0;			// Type conversion error.
}

/*
 * Check to see if the vectorizing dimensions on an input argument are
 * ok.  Arguments:
 * 1) The input argument.
 * 2) The number of vectorizing dimensions we have so far.  This is updated
 *    if we add more vectorizing dimensions.
 * 3) An array containing the existing vectorizing dimensions.
 * 4) The number of explicitly declared dimensions, i.e., 0 if this was
 *    declared as a scalar, 1 if a vector.  We vectorize only the dimensions
 *    higher than the explicitly declared ones.
 * 5) A value which is set to 0 if this argument is not vectorized.  This
 *    value is left unaltered if the argument is vectorized.
 *
 * Returns 0 if there was a problem, 1 if the dimensions were ok.
 */
int
_check_input_vectorize(const mxArray *arg,
                       int *n_vec_dim,
		       int _d[4],
		       int explicit_dims,
		       int *vec_stride)
{
  int v_idx;

  int n_dims = _n_dims(arg);

  if (n_dims > explicit_dims)	/* Any additional dimensions? */
  {
    if (*n_vec_dim == 0)	/* No vectorizing dimensions seen yet? */
    {				/* This defines the vectorizing dimensions. */
      *n_vec_dim = n_dims - explicit_dims; /* Remember the # of dims. */
      for (v_idx = 0; v_idx < 4-explicit_dims; ++v_idx)
        _d[v_idx] = _dim(arg, v_idx+explicit_dims); /* Remember this dim. */
    } 
    else			/* Already had some vectorizing dimensions. */
    {				/* These must match exactly. */
      for (v_idx = 0; v_idx < 4-explicit_dims; ++v_idx)
        if (_d[v_idx] != _dim(arg, v_idx+explicit_dims)) /* Wrong size? */
          return 0;		/* Error! */
    }
  }  
/*  else if (n_dims < explicit_dims) */ /* Too few dimensions? */
/*    return 0; */ /* We don't do this check because there's no way to
		    * distinguish between a vector and a 3x1 matrix. */
  else
    *vec_stride = 0;		/* Vectorization not required. */

  return 1;
}

/*
 * Same thing except for modify variables.  Arguments:
 * 1) The input argument.
 * 2) The number of vectorizing dimensions we have so far.
 * 3) An array containing the existing vectorizing dimensions.
 * 4) The number of explicitly declared dimensions, i.e., 0 if this was
 *    declared as a scalar, 1 if a vector.  We vectorize only the dimensions
 *    higher than the explicitly declared ones.
 * 5) A flag indicating whether this is the first modify variable.  This
 *    flag is passed by reference and updated by this subroutine.
 *
 * The vectorizing dimensions of modify arguments must exactly match those
 * specified for input variables.  The difference between this subroutine
 * and _check_input_vectorize is that only the first modify variable may
 * specify additional vectorizing dimensions.
 *
 * Returns 0 if there was a problem, 1 if the dimensions were ok.
 */
int
_check_modify_vectorize(const mxArray *arg,
		        int *n_vec_dim,
		        int _d[4],
		        int explicit_dims,
			int *first_modify_flag)
{
  int v_idx;

  int n_dims = _n_dims(arg);

  if (n_dims > explicit_dims)	/* Any additional dimensions? */
  {
    if (*n_vec_dim == 0 && *first_modify_flag)	/* No vectorizing dimensions seen yet? */
    {				/* This defines the vectorizing dimensions. */
      *n_vec_dim = n_dims - explicit_dims; /* Remember the # of dims. */
      for (v_idx = 0; v_idx < 4-explicit_dims; ++v_idx)
        _d[v_idx] = _dim(arg, v_idx+explicit_dims); /* Remember this dim. */
    } 
    else			/* Already had some vectorizing dimensions. */
    {				/* These must match exactly. */
      for (v_idx = 0; v_idx < 4-explicit_dims; ++v_idx)
        if (_d[v_idx] != _dim(arg, v_idx+explicit_dims)) /* Wrong size? */
          return 0;		/* Error! */
    }
  }  
/*  else if (n_dims < explicit_dims) */ /* Too few dimensions? */
/*    return 0; */ /* We don't do this check because there's no way to
		    * distinguish between a vector and a 3x1 matrix. */

  *first_modify_flag = 0;	/* Next modify variable will not be first. */
  return 1;
}


/*
 * Convert between classes, handling inheritance relationships.
 * Arguments:
 * 1) The pointer.
 * 2) The type code for its class.
 * 3) The type code for the class you want.
 *
 * Returns 0 if the conversion is illegal, or else returns the
 * desired pointer.
 * We assume that you have already verified that the type code does
 * not match, so the only valid possibility is an inheritance
 * relationship.
 */
static void *
__cvt_type(void *, unsigned, unsigned)
{
  return 0;
}

//
// Local functions dealing with pointers:
//
// Pointers are stored as complex numbers.  The real part is the pointer
// value, and the complex part is the type code.  Since the real part will be
// a double precision number, the pointer is guaranteed to fit, even on
// 64-bit machines.
//
// Fill an array with pointers.  Arguments:
// 1) A pointer to the array to fill.  The array is already the correct size.
// 2) The matlab object.
// 3) The pointer type code.
//
// Returns false if some of the pointers have the wrong type.
//
static int
_get_pointer(void **arr, const mxArray *mat, unsigned typecode)
{
  int idx;
  int n_elements;
  double *pr, *pi;

  if (!mxIsComplex(mat))	// Make sure it's the right type.
    return 0;

  n_elements = _arraylen(mat);	// Get the number of elements to convert.
  pr = mxGetPr(mat);		// Get a pointer to the real part.
  pi = mxGetPi(mat);		// Get a pointer to the complex part.
  for (idx = 0; idx < n_elements; ++idx)
  {				// Look at each element:
    unsigned this_typecode = (unsigned)*pi++; // Get the type code.
    if (this_typecode == typecode) // Correct type?
      *arr++ = *(void **)pr;	// Do the conversion.
    else
    {
      *arr = __cvt_type(*(void **)pr, this_typecode, typecode);
				// Check inheritance.
      if (*arr++ == 0) return 0; // Wrong type.
    }

    ++pr;			// Point to the next element.
  }

  return 1;			// No error.
}

//
// Load a matrix with a pointer or an array of pointers.  This assumes
// that the matrix has already been allocated to the correct size
// (that's how we know how many elements to convert).
//
static void
_put_pointer(mxArray *mat, void **ptr_array, double type_code)
{
  int idx;
  int n_elements;
  double *pr, *pi;
 
  n_elements = _arraylen(mat);	// Get the number of elements to convert.
  pr = mxGetPr(mat);		// Get a pointer to the real part.
  pi = mxGetPi(mat);		// Get a pointer to the complex part.

  for (idx = 0; idx < n_elements; ++idx)
  {
    *pi++ = type_code;		// Remember the type code.
    *pr = 0;			// Wipe out any extra bits the address
				// doesn't cover, in case we're on a
				// 32 bit machine.
    *(void **)pr = *ptr_array++; // Remember the address.
    ++pr;			// Advance the pointer.
  }
}
void _wrap_CataCamera_delete(int nlhs, mxArray **, int nrhs, const mxArray **prhs)
{
  if (nlhs != 0 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function CataCamera_delete");
  CataCamera * _arg_THIS;
  if (_n_dims(prhs[1]) > 0)
    mexErrMsgTxt("Error in dimension of argument THIS");
  if (!_get_pointer((void **)&_arg_THIS, prhs[1], 249056)) /* CataCamera * */
    mexErrMsgTxt("Wrong pointer type, expecting CataCamera * for argument THIS");

    delete _arg_THIS;
}

void _wrap_CataCamera_distortion(int nlhs, mxArray **, int nrhs, const mxArray **prhs)
{
  if (nlhs != 0 ||
      nrhs != 5+1)
    mexErrMsgTxt("Wrong number of arguments to function CataCamera_distortion");
  CataCamera * _arg_THIS;
  double _arg_mx_u;
  double _arg_my_u;
  double _arg_mx_d;
  double _arg_my_d;
  if (_n_dims(prhs[1]) > 0)
    mexErrMsgTxt("Error in dimension of argument THIS");
  if (!_get_pointer((void **)&_arg_THIS, prhs[1], 249056)) /* CataCamera * */
    mexErrMsgTxt("Wrong pointer type, expecting CataCamera * for argument THIS");

  if (_n_dims(prhs[2]) > 0)
    mexErrMsgTxt("Error in dimension of argument mx_u");
  if (!_get_numeric(prhs[2], &_arg_mx_u))
    mexErrMsgTxt("Expecting numeric scalar for argument mx_u");

  if (_n_dims(prhs[3]) > 0)
    mexErrMsgTxt("Error in dimension of argument my_u");
  if (!_get_numeric(prhs[3], &_arg_my_u))
    mexErrMsgTxt("Expecting numeric scalar for argument my_u");

  if (_n_dims(prhs[4]) > 0)
    mexErrMsgTxt("Error in dimension of argument mx_d");
  if (!_get_numeric(prhs[4], &_arg_mx_d))
    mexErrMsgTxt("Expecting numeric scalar for argument mx_d");

  if (_n_dims(prhs[5]) > 0)
    mexErrMsgTxt("Error in dimension of argument my_d");
  if (!_get_numeric(prhs[5], &_arg_my_d))
    mexErrMsgTxt("Expecting numeric scalar for argument my_d");

    (_arg_THIS)->distortion(_arg_mx_u, _arg_my_u, &_arg_mx_d, &_arg_my_d);
}

void _wrap_CataCamera_getV(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs > 1 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function CataCamera_getV");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  CataCamera * *_arg_THIS;
  double *_arg_V;
  int _vecstride_THIS = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 0, &_vecstride_THIS))
    mexErrMsgTxt("Error in dimension of argument THIS");
  _arg_THIS =
    MEM_ALLOC(CataCamera * *, _arraylen(prhs[1]), sizeof (CataCamera *));
  if (!_get_pointer((void **)_arg_THIS, prhs[1], 249056)) /* CataCamera * */
    mexErrMsgTxt("Wrong pointer type, expecting CataCamera * for argument THIS");

  {
    int _ds[] = { 1, 11, _d[0] , _d[1]  };
    plhs[0] = mxCreateNumericArray(max((2 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_V = mxGetPr(plhs[0]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    (_arg_THIS[_vecstride_THIS*_vidx])->getV(&_arg_V[1*11*_vidx]);
  }
}

void _wrap_CataCamera_lift_projective(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs != 3 ||
      nrhs != 3+1)
    mexErrMsgTxt("Wrong number of arguments to function CataCamera_lift_projective");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  CataCamera * *_arg_THIS;
  double *_arg_u;
  double *_arg_v;
  double *_arg_X;
  double *_arg_Y;
  double *_arg_Z;
  int _vecstride_THIS = 1;
  int _vecstride_u = 1;
  int _vecstride_v = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 0, &_vecstride_THIS))
    mexErrMsgTxt("Error in dimension of argument THIS");
  _arg_THIS =
    MEM_ALLOC(CataCamera * *, _arraylen(prhs[1]), sizeof (CataCamera *));
  if (!_get_pointer((void **)_arg_THIS, prhs[1], 249056)) /* CataCamera * */
    mexErrMsgTxt("Wrong pointer type, expecting CataCamera * for argument THIS");

  if (!_check_input_vectorize(prhs[2], &_vec_n, _d, 0, &_vecstride_u))
    mexErrMsgTxt("Error in dimension of argument u");
  if (mxIsDouble(prhs[2]))
    _arg_u = mxGetPr(prhs[2]);
  else
  {
    _arg_u = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_u))
      mexErrMsgTxt("Expecting numeric matrix for argument u");
  }

  if (!_check_input_vectorize(prhs[3], &_vec_n, _d, 0, &_vecstride_v))
    mexErrMsgTxt("Error in dimension of argument v");
  if (mxIsDouble(prhs[3]))
    _arg_v = mxGetPr(prhs[3]);
  else
  {
    _arg_v = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_v))
      mexErrMsgTxt("Expecting numeric matrix for argument v");
  }

  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[0] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_X = mxGetPr(plhs[0]);
  }
  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[1] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_Y = mxGetPr(plhs[1]);
  }
  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[2] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_Z = mxGetPr(plhs[2]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    (_arg_THIS[_vecstride_THIS*_vidx])->lift_projective(_arg_u[_vecstride_u*_vidx], _arg_v[_vecstride_v*_vidx], &_arg_X[_vidx], &_arg_Y[_vidx], &_arg_Z[_vidx]);
  }
}

void _wrap_CataCamera_lift_sphere(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs != 3 ||
      nrhs != 3+1)
    mexErrMsgTxt("Wrong number of arguments to function CataCamera_lift_sphere");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  CataCamera * *_arg_THIS;
  double *_arg_u;
  double *_arg_v;
  double *_arg_X;
  double *_arg_Y;
  double *_arg_Z;
  int _vecstride_THIS = 1;
  int _vecstride_u = 1;
  int _vecstride_v = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 0, &_vecstride_THIS))
    mexErrMsgTxt("Error in dimension of argument THIS");
  _arg_THIS =
    MEM_ALLOC(CataCamera * *, _arraylen(prhs[1]), sizeof (CataCamera *));
  if (!_get_pointer((void **)_arg_THIS, prhs[1], 249056)) /* CataCamera * */
    mexErrMsgTxt("Wrong pointer type, expecting CataCamera * for argument THIS");

  if (!_check_input_vectorize(prhs[2], &_vec_n, _d, 0, &_vecstride_u))
    mexErrMsgTxt("Error in dimension of argument u");
  if (mxIsDouble(prhs[2]))
    _arg_u = mxGetPr(prhs[2]);
  else
  {
    _arg_u = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_u))
      mexErrMsgTxt("Expecting numeric matrix for argument u");
  }

  if (!_check_input_vectorize(prhs[3], &_vec_n, _d, 0, &_vecstride_v))
    mexErrMsgTxt("Error in dimension of argument v");
  if (mxIsDouble(prhs[3]))
    _arg_v = mxGetPr(prhs[3]);
  else
  {
    _arg_v = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_v))
      mexErrMsgTxt("Expecting numeric matrix for argument v");
  }

  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[0] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_X = mxGetPr(plhs[0]);
  }
  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[1] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_Y = mxGetPr(plhs[1]);
  }
  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[2] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_Z = mxGetPr(plhs[2]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    (_arg_THIS[_vecstride_THIS*_vidx])->lift_sphere(_arg_u[_vecstride_u*_vidx], _arg_v[_vecstride_v*_vidx], &_arg_X[_vidx], &_arg_Y[_vidx], &_arg_Z[_vidx]);
  }
}

void _wrap_CataCamera_new(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs > 1 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function CataCamera_new");
  char * _arg_fileName;
  CataCamera * _arg_retval;
  if (0 > 0)
    mexErrMsgTxt("Error in dimension of argument fileName");
  if (!mxIsChar(prhs[1]))
    mexErrMsgTxt("Expecting string for argument fileName");
  _arg_fileName = MEM_ALLOC(char *, mxGetN(prhs[1]) + 1, sizeof (char));
  mxGetString(prhs[1], _arg_fileName, mxGetN(prhs[1])+1);

  plhs[0] = mxCreateDoubleMatrix(1, 1, mxCOMPLEX);
    _arg_retval = (CataCamera *)
      new CataCamera(_arg_fileName);
  _put_pointer(plhs[0], (void **)&_arg_retval, 249056); /* CataCamera * */
}

void _wrap_CataCamera_reprojectionDist(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs > 1 ||
      nrhs != 7+1)
    mexErrMsgTxt("Wrong number of arguments to function CataCamera_reprojectionDist");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  CataCamera * *_arg_THIS;
  double *_arg_x1;
  double *_arg_y1;
  double *_arg_z1;
  double *_arg_x2;
  double *_arg_y2;
  double *_arg_z2;
  double *_arg_dist;
  int _vecstride_THIS = 1;
  int _vecstride_x1 = 1;
  int _vecstride_y1 = 1;
  int _vecstride_z1 = 1;
  int _vecstride_x2 = 1;
  int _vecstride_y2 = 1;
  int _vecstride_z2 = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 0, &_vecstride_THIS))
    mexErrMsgTxt("Error in dimension of argument THIS");
  _arg_THIS =
    MEM_ALLOC(CataCamera * *, _arraylen(prhs[1]), sizeof (CataCamera *));
  if (!_get_pointer((void **)_arg_THIS, prhs[1], 249056)) /* CataCamera * */
    mexErrMsgTxt("Wrong pointer type, expecting CataCamera * for argument THIS");

  if (!_check_input_vectorize(prhs[2], &_vec_n, _d, 0, &_vecstride_x1))
    mexErrMsgTxt("Error in dimension of argument x1");
  if (mxIsDouble(prhs[2]))
    _arg_x1 = mxGetPr(prhs[2]);
  else
  {
    _arg_x1 = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_x1))
      mexErrMsgTxt("Expecting numeric matrix for argument x1");
  }

  if (!_check_input_vectorize(prhs[3], &_vec_n, _d, 0, &_vecstride_y1))
    mexErrMsgTxt("Error in dimension of argument y1");
  if (mxIsDouble(prhs[3]))
    _arg_y1 = mxGetPr(prhs[3]);
  else
  {
    _arg_y1 = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_y1))
      mexErrMsgTxt("Expecting numeric matrix for argument y1");
  }

  if (!_check_input_vectorize(prhs[4], &_vec_n, _d, 0, &_vecstride_z1))
    mexErrMsgTxt("Error in dimension of argument z1");
  if (mxIsDouble(prhs[4]))
    _arg_z1 = mxGetPr(prhs[4]);
  else
  {
    _arg_z1 = MEM_ALLOC(double *, _arraylen(prhs[4]), sizeof (double));
    if (!_get_numeric(prhs[4], _arg_z1))
      mexErrMsgTxt("Expecting numeric matrix for argument z1");
  }

  if (!_check_input_vectorize(prhs[5], &_vec_n, _d, 0, &_vecstride_x2))
    mexErrMsgTxt("Error in dimension of argument x2");
  if (mxIsDouble(prhs[5]))
    _arg_x2 = mxGetPr(prhs[5]);
  else
  {
    _arg_x2 = MEM_ALLOC(double *, _arraylen(prhs[5]), sizeof (double));
    if (!_get_numeric(prhs[5], _arg_x2))
      mexErrMsgTxt("Expecting numeric matrix for argument x2");
  }

  if (!_check_input_vectorize(prhs[6], &_vec_n, _d, 0, &_vecstride_y2))
    mexErrMsgTxt("Error in dimension of argument y2");
  if (mxIsDouble(prhs[6]))
    _arg_y2 = mxGetPr(prhs[6]);
  else
  {
    _arg_y2 = MEM_ALLOC(double *, _arraylen(prhs[6]), sizeof (double));
    if (!_get_numeric(prhs[6], _arg_y2))
      mexErrMsgTxt("Expecting numeric matrix for argument y2");
  }

  if (!_check_input_vectorize(prhs[7], &_vec_n, _d, 0, &_vecstride_z2))
    mexErrMsgTxt("Error in dimension of argument z2");
  if (mxIsDouble(prhs[7]))
    _arg_z2 = mxGetPr(prhs[7]);
  else
  {
    _arg_z2 = MEM_ALLOC(double *, _arraylen(prhs[7]), sizeof (double));
    if (!_get_numeric(prhs[7], _arg_z2))
      mexErrMsgTxt("Expecting numeric matrix for argument z2");
  }

  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[0] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_dist = mxGetPr(plhs[0]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    (_arg_THIS[_vecstride_THIS*_vidx])->reprojectionDist(_arg_x1[_vecstride_x1*_vidx], _arg_y1[_vecstride_y1*_vidx], _arg_z1[_vecstride_z1*_vidx], _arg_x2[_vecstride_x2*_vidx], _arg_y2[_vecstride_y2*_vidx], _arg_z2[_vecstride_z2*_vidx], &_arg_dist[_vidx]);
  }
}

void _wrap_CataCamera_space2plane(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs != 8 ||
      nrhs != 4+1)
    mexErrMsgTxt("Wrong number of arguments to function CataCamera_space2plane");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  CataCamera * *_arg_THIS;
  double *_arg_x;
  double *_arg_y;
  double *_arg_z;
  double *_arg_u;
  double *_arg_v;
  double *_arg_dudx;
  double *_arg_dvdx;
  double *_arg_dudy;
  double *_arg_dvdy;
  double *_arg_dudz;
  double *_arg_dvdz;
  int _vecstride_THIS = 1;
  int _vecstride_x = 1;
  int _vecstride_y = 1;
  int _vecstride_z = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 0, &_vecstride_THIS))
    mexErrMsgTxt("Error in dimension of argument THIS");
  _arg_THIS =
    MEM_ALLOC(CataCamera * *, _arraylen(prhs[1]), sizeof (CataCamera *));
  if (!_get_pointer((void **)_arg_THIS, prhs[1], 249056)) /* CataCamera * */
    mexErrMsgTxt("Wrong pointer type, expecting CataCamera * for argument THIS");

  if (!_check_input_vectorize(prhs[2], &_vec_n, _d, 0, &_vecstride_x))
    mexErrMsgTxt("Error in dimension of argument x");
  if (mxIsDouble(prhs[2]))
    _arg_x = mxGetPr(prhs[2]);
  else
  {
    _arg_x = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_x))
      mexErrMsgTxt("Expecting numeric matrix for argument x");
  }

  if (!_check_input_vectorize(prhs[3], &_vec_n, _d, 0, &_vecstride_y))
    mexErrMsgTxt("Error in dimension of argument y");
  if (mxIsDouble(prhs[3]))
    _arg_y = mxGetPr(prhs[3]);
  else
  {
    _arg_y = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_y))
      mexErrMsgTxt("Expecting numeric matrix for argument y");
  }

  if (!_check_input_vectorize(prhs[4], &_vec_n, _d, 0, &_vecstride_z))
    mexErrMsgTxt("Error in dimension of argument z");
  if (mxIsDouble(prhs[4]))
    _arg_z = mxGetPr(prhs[4]);
  else
  {
    _arg_z = MEM_ALLOC(double *, _arraylen(prhs[4]), sizeof (double));
    if (!_get_numeric(prhs[4], _arg_z))
      mexErrMsgTxt("Expecting numeric matrix for argument z");
  }

  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[0] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_u = mxGetPr(plhs[0]);
  }
  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[1] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_v = mxGetPr(plhs[1]);
  }
  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[2] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_dudx = mxGetPr(plhs[2]);
  }
  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[3] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_dvdx = mxGetPr(plhs[3]);
  }
  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[4] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_dudy = mxGetPr(plhs[4]);
  }
  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[5] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_dvdy = mxGetPr(plhs[5]);
  }
  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[6] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_dudz = mxGetPr(plhs[6]);
  }
  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[7] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_dvdz = mxGetPr(plhs[7]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    (_arg_THIS[_vecstride_THIS*_vidx])->space2plane(_arg_x[_vecstride_x*_vidx], _arg_y[_vecstride_y*_vidx], _arg_z[_vecstride_z*_vidx], &_arg_u[_vidx], &_arg_v[_vidx], &_arg_dudx[_vidx], &_arg_dvdx[_vidx], &_arg_dudy[_vidx], &_arg_dvdy[_vidx], &_arg_dudz[_vidx], &_arg_dvdz[_vidx]);
  }
}

void _wrap_CataCamera_undist2plane(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs != 2 ||
      nrhs != 3+1)
    mexErrMsgTxt("Wrong number of arguments to function CataCamera_undist2plane");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  CataCamera * *_arg_THIS;
  double *_arg_mx_u;
  double *_arg_my_u;
  double *_arg_u;
  double *_arg_v;
  int _vecstride_THIS = 1;
  int _vecstride_mx_u = 1;
  int _vecstride_my_u = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 0, &_vecstride_THIS))
    mexErrMsgTxt("Error in dimension of argument THIS");
  _arg_THIS =
    MEM_ALLOC(CataCamera * *, _arraylen(prhs[1]), sizeof (CataCamera *));
  if (!_get_pointer((void **)_arg_THIS, prhs[1], 249056)) /* CataCamera * */
    mexErrMsgTxt("Wrong pointer type, expecting CataCamera * for argument THIS");

  if (!_check_input_vectorize(prhs[2], &_vec_n, _d, 0, &_vecstride_mx_u))
    mexErrMsgTxt("Error in dimension of argument mx_u");
  if (mxIsDouble(prhs[2]))
    _arg_mx_u = mxGetPr(prhs[2]);
  else
  {
    _arg_mx_u = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_mx_u))
      mexErrMsgTxt("Expecting numeric matrix for argument mx_u");
  }

  if (!_check_input_vectorize(prhs[3], &_vec_n, _d, 0, &_vecstride_my_u))
    mexErrMsgTxt("Error in dimension of argument my_u");
  if (mxIsDouble(prhs[3]))
    _arg_my_u = mxGetPr(prhs[3]);
  else
  {
    _arg_my_u = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_my_u))
      mexErrMsgTxt("Expecting numeric matrix for argument my_u");
  }

  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[0] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_u = mxGetPr(plhs[0]);
  }
  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[1] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_v = mxGetPr(plhs[1]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    (_arg_THIS[_vecstride_THIS*_vidx])->undist2plane(_arg_mx_u[_vecstride_mx_u*_vidx], _arg_my_u[_vecstride_my_u*_vidx], &_arg_u[_vidx], &_arg_v[_vidx]);
  }
}



/*
 * The main dispatch function.  This function calls the appropriate wrapper
 * based on the value of the first argument.
 */

#ifdef __cplusplus
extern "C" {
#endif

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) {
  if (nrhs == 0 || !mxIsDouble(prhs[0]) ||
      mxGetM(prhs[0]) != 1 || mxGetN(prhs[0]) != 1)
    mexErrMsgTxt("Illegal call to mex functions in wrapCataCamera");
  switch ((int)(mxGetScalar(prhs[0]))) {
  case 0: _wrap_CataCamera_delete(nlhs, plhs, nrhs, prhs); break;
  case 1: _wrap_CataCamera_distortion(nlhs, plhs, nrhs, prhs); break;
  case 2: _wrap_CataCamera_getV(nlhs, plhs, nrhs, prhs); break;
  case 3: _wrap_CataCamera_lift_projective(nlhs, plhs, nrhs, prhs); break;
  case 4: _wrap_CataCamera_lift_sphere(nlhs, plhs, nrhs, prhs); break;
  case 5: _wrap_CataCamera_new(nlhs, plhs, nrhs, prhs); break;
  case 6: _wrap_CataCamera_reprojectionDist(nlhs, plhs, nrhs, prhs); break;
  case 7: _wrap_CataCamera_space2plane(nlhs, plhs, nrhs, prhs); break;
  case 8: _wrap_CataCamera_undist2plane(nlhs, plhs, nrhs, prhs); break;

  default: mexErrMsgTxt("Illegal function ID parameter");
  }
}

#ifdef __cplusplus
}
#endif
